/*
 * crypto_kem/try.c version 20200406
 * D. J. Bernstein
 * Public domain.
 * Auto-generated by trygen.py; do not edit.
 */

#include "crypto_kem.h"
#include "try.h"

const char *primitiveimplementation = crypto_kem_IMPLEMENTATION;

#define TUNE_BYTES 1536
#ifdef SMALL
#define MAXTEST_BYTES 128
#else
#define MAXTEST_BYTES 4096
#endif
#ifdef SMALL
#define LOOPS 8
#else
#define LOOPS 64
#endif

static unsigned char *p;
static unsigned char *s;
static unsigned char *k;
static unsigned char *c;
static unsigned char *t;
static unsigned char *p2;
static unsigned char *s2;
static unsigned char *k2;
static unsigned char *c2;
static unsigned char *t2;
#define plen crypto_kem_PUBLICKEYBYTES
#define slen crypto_kem_SECRETKEYBYTES
#define klen crypto_kem_BYTES
#define clen crypto_kem_CIPHERTEXTBYTES
#define tlen crypto_kem_BYTES

void preallocate(void)
{
#ifdef RAND_R_PRNG_NOT_SEEDED
  RAND_status();
#endif
}

void allocate(void)
{
  unsigned long long alloclen = 0;
  if (alloclen < TUNE_BYTES) alloclen = TUNE_BYTES;
  if (alloclen < MAXTEST_BYTES) alloclen = MAXTEST_BYTES;
  if (alloclen < crypto_kem_PUBLICKEYBYTES) alloclen = crypto_kem_PUBLICKEYBYTES;
  if (alloclen < crypto_kem_SECRETKEYBYTES) alloclen = crypto_kem_SECRETKEYBYTES;
  if (alloclen < crypto_kem_BYTES) alloclen = crypto_kem_BYTES;
  if (alloclen < crypto_kem_CIPHERTEXTBYTES) alloclen = crypto_kem_CIPHERTEXTBYTES;
  if (alloclen < crypto_kem_BYTES) alloclen = crypto_kem_BYTES;
  p = alignedcalloc(alloclen);
  s = alignedcalloc(alloclen);
  k = alignedcalloc(alloclen);
  c = alignedcalloc(alloclen);
  t = alignedcalloc(alloclen);
  p2 = alignedcalloc(alloclen);
  s2 = alignedcalloc(alloclen);
  k2 = alignedcalloc(alloclen);
  c2 = alignedcalloc(alloclen);
  t2 = alignedcalloc(alloclen);
}

void predoit(void)
{
  crypto_kem_keypair(p,s);
}

void doit(void)
{
  crypto_kem_enc(c,k,p);
  crypto_kem_dec(t,c,s);
}
